var PrefUtil = {
	PREF : Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch),
	
	KEY_DOMAIN_LIST : "com.kenmaz.confirm-address.domain-list",
	KEY_NOT_DISPLAY : "com.kenmaz.confirm-address.not-display",
	IS_COUNT_DOWN   : "com.kenmaz.confirm-address.is-countdown",
	COUNT_DOWN_TIME : "com.kenmaz.confirm-address.countdown-time",
	IS_SKIP_BUTTON  : "com.kenmaz.confirm-address.is-skip-button",
	IS_CHECK_SUBJECT: "com.kenmaz.confirm-address.is-check-subject",
	IS_CHECK_SENDER : "com.kenmaz.confirm-address.is-check-sender",
	TREE_STYLE      : "com.kenmaz.confirm-address.tree-style",
	COUNT_DOWN_TIME : "com.kenmaz.confirm-address.cd-time",

	getDomainList : function() {
		return this.getPref(PrefUtil.KEY_DOMAIN_LIST);
	},
	setDomainList : function(listStr) {
		PrefUtil.setPref(PrefUtil.KEY_DOMAIN_LIST, listStr);
	},
	
	isNotDisplay : function() {
		return this.getPref(PrefUtil.KEY_NOT_DISPLAY);
	},
	setNotDisplay : function(b) {
		PrefUtil.setPref(PrefUtil.KEY_NOT_DISPLAY, b);
	},
	
	isCountDown : function(){
		return this.getPref(PrefUtil.IS_COUNT_DOWN);
	},
	setCountDown : function(b){
		PrefUtil.setPref(PrefUtil.IS_COUNT_DOWN, b);
	},

	getCountDownTime : function(){
		return this.getPref(PrefUtil.COUNT_DOWN_TIME);
	},
	setCountDownTime : function(t){
		PrefUtil.setPref(PrefUtil.COUNT_DOWN_TIME, t);
	},

	isSkipButton : function(){
		return this.getPref(PrefUtil.IS_SKIP_BUTTON);
	},
	setSkipButton : function(t){
		PrefUtil.setPref(PrefUtil.IS_SKIP_BUTTON, t);
	},

	isCheckSubject : function(){
		return this.getPref(PrefUtil.IS_CHECK_SUBJECT);
	},
	setCheckSubject : function(t){
		PrefUtil.setPref(PrefUtil.IS_CHECK_SUBJECT, t);
	},

	isCheckSender : function(){
		return this.getPref(PrefUtil.IS_CHECK_SENDER);
	},
	setCheckSender : function(t){
		PrefUtil.setPref(PrefUtil.IS_CHECK_SENDER, t);
	},
    
	isTreeStyle : function(){
		return this.getPref(PrefUtil.TREE_STYLE);
	},
	setTreeStyle : function(t){
		PrefUtil.setPref(PrefUtil.TREE_STYLE, t);
	},

	getPref : function(key) {
		try{
			const nsIPrefBranch = Components.interfaces.nsIPrefBranch;
			var value = "";

			var type = this.PREF.getPrefType(key);
			switch (type) {
			case nsIPrefBranch.PREF_STRING:
				value = this.PREF.getCharPref(key);
				break;
				
			case nsIPrefBranch.PREF_INT:
				value = this.PREF.getIntPref(key);
				break;
				
		    case nsIPrefBranch.PREF_BOOL:
			default:
				value = this.PREF.getBoolPref(key);
				break;
			}
			dump("[GET PREF] key="+ key + ", value=" + value + "\n");
			return value;
			
		}catch(e){
			dump("[GET PREF ERROR] key="+ key + "\n");
			return null;
		}
	},
	setPref : function(key, value) {
		var type = typeof(value);
		if(type == "string"){
			PrefUtil.PREF.setCharPref(key, value);
		}else if(type == "boolean"){
			PrefUtil.PREF.setBoolPref(key, value);
		}else if(type == "integer"){
			PrefUtil.PREF.setIntPref(key, value);
		}else{
		}
		dump("[SET PREF] key="+ key + ", value=" + value + "\n");
	}
}