var selectedItem;
var domainstring;
var addressstring;

function startup(){

	var sBundle = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
	var bstrings = sBundle.createBundle("chrome://confirm-address/locale/confirm-address.properties");
	domainstring  = bstrings.GetStringFromName("confirm.setting.domain");
	addressstring = bstrings.GetStringFromName("confirm.setting.address");

	//init domain list.
	document.getElementById("add"   ).addEventListener('command', add   , true);
	document.getElementById("edit"  ).addEventListener('command', edit  , true);
	document.getElementById("remove").addEventListener('command', remove, true);
	var groupList = document.getElementById("group-list");

	var domains = PrefUtil.getDomainList();
	dump("[registed domains] " + domains + "\n");
	
	if(domains != null){
		var domainList = domains.split(",");
		for(var i=0; i < domainList.length; i++){
			var listitem = document.createElement("listitem");
			listitem.setAttribute("id", Math.random());
			
			var cell1 = document.createElement("listcell");
			cell1.setAttribute("label", domainList[i]);
			cell1.setAttribute("id", Math.random());
			listitem.appendChild(cell1);
			
			var cell2 = document.createElement("listcell");
			if( domainList[i].indexOf("@") != -1 ){
				cell2.setAttribute("label", addressstring );
			}else{
				cell2.setAttribute("label", domainstring );
			}
			cell2.setAttribute("id", Math.random());
			listitem.appendChild(cell2);

			groupList.appendChild(listitem);
		}
	}
	
	document.getElementById("chk-sender" ).checked = PrefUtil.isCheckSender();
	document.getElementById("chk-subject").checked = PrefUtil.isCheckSubject();
	document.getElementById("not-display").checked = PrefUtil.isNotDisplay();

	//init checkbox [countdown]
	var cdBox = document.getElementById("countdown");
	var cdTimeBox = document.getElementById("countdown-time");
	var cdSkipButton = document.getElementById("dspskipbtn");
    var isCountDown = PrefUtil.isCountDown();

	cdBox.checked =  isCountDown;
	cdBox.addEventListener('command',
		function(event){
			cdTimeBox.disabled    = !cdBox.checked;
			cdSkipButton.disabled = !cdBox.checked;
		},
		true);

    cdTimeBox.disable     = !isCountDown;
	cdSkipButton.disable  = !isCountDown;

    cdTimeBox.value = PrefUtil.getCountDownTime();
    cdSkipButton.checked  = PrefUtil.isSkipButton();
}

function add(event){
	window.confirmOK = false;
	window.domainName = null;
	window.openDialog("chrome://confirm-address/content/setting-add-domain.xul",
		"ConfirmAddressDialog", "chrome,modal,titlebar,centerscreen", window);

	if(window.confirmOK){
		var domainName = window.domainName;
		
		if(domainName.length > 0){
			dump("[add!] " + domainName + "\n");
			var groupList = document.getElementById("group-list");
			var listitem = document.createElement("listitem");
			listitem.setAttribute("id", Math.random());

			var cell1 = document.createElement("listcell");
			cell1.setAttribute("label", domainName);
			cell1.setAttribute("id", Math.random());
			listitem.appendChild(cell1);

			var cell2 = document.createElement("listcell");
			if(domainName.indexOf("@") != -1 ){
				cell2.setAttribute("label", addressstring );
			}else{
				cell2.setAttribute("label", domainstring  );
			}
			cell2.setAttribute("id", Math.random());
			listitem.appendChild(cell2);

			groupList.appendChild(listitem);
		}
	}
}
function edit(event){
	window.confirmOK = false;
	window.domainName = selectedItem.childNodes[0].getAttribute("label");
	window.openDialog("chrome://confirm-address/content/setting-add-domain.xul",
		"ConfirmAddressDialog", "chrome,modal,titlebar,centerscreen", window);

	if(window.confirmOK){
		var domainName = window.domainName;
		if(domainName.length > 0){
			dump("[edit!] " + domainName + "\n");
			var ndList = selectedItem.childNodes;
			ndList[0].setAttribute("label", domainName );
			if( domainName.indexOf("@") != -1 ){
				ndList[1].setAttribute("label", addressstring );
			}else{
				ndList[1].setAttribute("label", domainstring );
			}
		}
	}
}
function remove(event){
	var groupList = document.getElementById("group-list");
	dump("[remove] "+selectedItem + "\n");
	groupList.removeChild(selectedItem);
}

function selectList(item){
	selectedItem = item;
}

function doOK(){
	dump("[OK]\n");

	//ドメイン設定保存
	var domainList = new Array();
	var groupList = document.getElementById("group-list");
	var nodes = groupList.childNodes;
	for(i = 0; i < nodes.length; i++){
		if(nodes[i].nodeName == "listitem"){
			domainList.push(nodes[i].childNodes[0].getAttribute("label"));
		}
	}
	var domainListStr = domainList.join(",");
    PrefUtil.setDomainList(domainListStr);
	dump( "[domain]"+ domainListStr + "\n" );

	//チェックボックス設定保存
    PrefUtil.setCheckSender ( document.getElementById("chk-sender" ).checked );
    PrefUtil.setCheckSubject( document.getElementById("chk-subject").checked );
    PrefUtil.setNotDisplay  ( document.getElementById("not-display").checked );
    PrefUtil.setCountDown   ( document.getElementById("countdown"  ).checked );
    PrefUtil.setSkipButton  ( document.getElementById("dspskipbtn" ).checked );

	var cdTime = document.getElementById("countdown-time").value;
	if(isNaN(Number(cdTime)) && isCountdown ){
		alert("please input integer");
		return false;
	}
    PrefUtil.setCountDownTime( cdTime );

	return true;
}

function doCancel(){
	dump("[cancel]\n");
	return true;
}

